/*	AMX Mod X script.

	Subnet Ban Plugin by Zetex.

	  . :
		 http://amx-x.ru/viewtopic.php?f=11&t=6093 - Russian AMXX Community.
		 http://aghl.ru/forum/viewtopic.php?f=19&t=691 - Russian AG and HL Community.

	:
		 sb_ban <  CIDR > -  .
		 sb_unban <  CIDR > -  .
		 sb_banlist <> -    .
		 sb_who -  IP   .

	:
		 sb_ignore_steam "0/1" - ./.   Steam .
		 sb_notification_connected "0/1" - ./.    .
		 sb_logging "0/1" - ./.    .../subnet_ban.log

	:
		 Metamod  dproto,    0.4.4   (       ).

	:
		   "subnet_ban.amxx"   plugins.
		   "subnet_ban.txt"   data/lang.
		   "subnet_ban.amxx" ( )   "config/plugins.ini".

	 :
		 Lev, Zefir, NSR, makcumka, rfc1, mazdan.

	 :
		v1.0 [20.10.2011]
			  .
		v1.1 [24.10.2011]
			    "sb_kick_reason".
		v1.2 [28.10.2011]
			    "sb_ignore_steam".
		v1.3 [02.11.2011]
			   .
		v1.4 [05.11.2011]
			  .
			   .
			    .
		v1.5 [11.03.2012]
			    .
			   .
			    "sb_notification_connected".
		v1.5.1 [15.03.2012]
			       IP  .
		v1.6 [17.03.2012]
			     .    CIDR .
			    "sb_logging".
		v1.7 [16.04.2012]
			   "sb_kick_reason",       .
			      HLTV.
			       amx_help.
		v1.8 [21.05.2012]
			     .
		v1.8.32 [10.11.2012]
			   .
			    "subnet_ban.txt".
*/

//  ,      Dproto:
#define   USING_DPROTO

// Settings:
#pragma   semicolon			1
#pragma   ctrlchar			'\'

// Includes:
#include  <amxmodx>
#include  <amxmisc>
#include  <ip_stocks>
#if defined USING_DPROTO
#include  <dproto_stocks>
#endif

// Constants:
#define   ADMIN_DEF_FLAG	ADMIN_LEVEL_A
#define   ADMIN_FLAGS		(ADMIN_IMMUNITY | ADMIN_DEF_FLAG)
#define   MAXPLAYERS		32
#define   LISTAMOUNT		10
#define   CONNECTION_SND	"buttons/bell1.wav"
#define   PREFIX			"[SB]"

// Version:
#define   SB_VERSION_CVAR	"sb_version"
#define   SB_VERSION_STRING	"1.8.32"
#define   SB_VERSION_FLAGS	(FCVAR_SERVER | FCVAR_SPONLY | FCVAR_UNLOGGED)

// Global functions:
new Array:_subnet;
new data_dir[128], logs_dir[128], subnets_file[64], logs_file[64];
new pcvar_notification_connected, pcvar_logging;
#if defined USING_DPROTO
new pcvar_ignore_steam;
#endif

public plugin_init()
{
	register_plugin("Subnet Ban Plugin", SB_VERSION_STRING, "Zetex");
	register_dictionary("subnet_ban.txt");

	register_cvar(SB_VERSION_CVAR, SB_VERSION_STRING, SB_VERSION_FLAGS);
	set_cvar_string(SB_VERSION_CVAR, SB_VERSION_STRING);

	pcvar_notification_connected = register_cvar("sb_notification_connected", "1");
	pcvar_logging = register_cvar("sb_logging", "1");

#if defined USING_DPROTO
	pcvar_ignore_steam = register_cvar("sb_ignore_steam", "1");
#endif

	register_concmd("sb_ban", "concmd_Ban", ADMIN_DEF_FLAG, "<subnet in CIDR format> - add subnet to banlist");
	register_concmd("sb_unban", "concmd_Unban", ADMIN_DEF_FLAG, "<subnet in CIDR format> - remove subnet from banlist");
	register_concmd("sb_banlist", "concmd_Banlist", ADMIN_DEF_FLAG, "<page> - show list of banned subnets");
	register_concmd("sb_who", "concmd_Who", ADMIN_DEF_FLAG, "- show ip addresses of players on server");

	get_localinfo("amxx_datadir", data_dir, charsmax(data_dir));
	get_localinfo("amxx_logs", logs_dir, charsmax(logs_dir));
	format(subnets_file, charsmax(subnets_file), "%s/subnets.ini", data_dir);
	format(logs_file, charsmax(logs_file), "%s/subnet_ban.log", logs_dir);
}

public plugin_precache()
{
	_subnet = ArrayCreate(32, 1);
	precache_sound(CONNECTION_SND);
	set_task(1.0, "cache_variables");
}

public plugin_cfg()
{
	if (!file_exists(subnets_file))
	{
		if (get_pcvar_num(pcvar_logging) != 0)
		{
			log_to_file(logs_file, "File with subnets is missing. Creating...");
		}

		new moddir[16], loc[128];
		get_modname(moddir, charsmax(moddir));
		format(loc, charsmax(loc), "; File location: %s/%s", moddir, subnets_file);

		write_file(subnets_file, loc);
		write_file(subnets_file, "; Line starting with \";\", \"#\", \"//\" is a comment.");
	}
}

public plugin_end()
{
	ArrayDestroy(_subnet);
}

public client_authorized(id)
{
	if (is_user_bot(id) || is_user_hltv(id))
		return PLUGIN_HANDLED;

#if defined ADMIN_FLAGS
	if (get_user_flags(id) & ADMIN_FLAGS)
		return PLUGIN_HANDLED;
#endif

#if defined USING_DPROTO
	if (get_pcvar_num(pcvar_ignore_steam) != 0 && is_user_steam(id))
		return PLUGIN_HANDLED;
#endif

	new ip[16], subnet[32], net, mask;
	get_user_ip(id, ip, charsmax(ip), 1);

	for (new i = 0; i < subnets_num(); i++)
	{
		ArrayGetString(_subnet, i, subnet, charsmax(subnet));
		range1(subnet, net, mask);

		if (net == ip_to_long(ip) & mask)
		{
			if (get_pcvar_num(pcvar_logging) != 0)
			{
				new name[32], authid[32];
				get_user_name(id, name, charsmax(name));
				get_user_authid(id, authid, charsmax(authid));
				remove(authid, charsmax(authid), "STEAM_");
				remove(authid, charsmax(authid), "VALVE_");

				log_to_file(logs_file, "%s is kicked; IP = %s; Subnet = %s; SteamID = %s", name, ip, subnet, authid);
			}

			server_cmd("kick \"#%d\" %L", get_user_userid(id), id, "SB_REJMSG");
		}
	}

	return PLUGIN_CONTINUE;
}

public client_putinserver(id)
{
	if (get_pcvar_num(pcvar_notification_connected) != 0)
	{
		set_task(3.0, "client_connected", id);
	}
}

public client_connected(id)
{
	new name[32], ip[16], players[MAXPLAYERS], num;
	get_user_name(id, name, charsmax(name));
	get_user_ip(id, ip, charsmax(ip), 1);
	get_players(players, num);

	for (new i = 0; i < num; i++)
	{
		client_print(players[i], print_chat, "%L", id, "SB_AUTHORIZED", name, ip);
		client_cmd(players[i], "speak \"%s\"", CONNECTION_SND);
	}
}

public client_disconnect(id)
{
	if (task_exists(id))
	{
		remove_task(id);
	}
}

public concmd_Ban(id, level, cid)
{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;

	new arg[32];
	read_argv(1, arg, charsmax(arg));

	if (is_invalid_str(arg) || !is_valid_subnet(arg))
	{
		server_print("%s %L", PREFIX, id, "SB_UNKNOWN_INPUT", arg);
		return PLUGIN_HANDLED;
	}

	if (file_exists(subnets_file))
	{
		new line = 0, linedata[1024], len;

		while ((line = read_file(subnets_file, line, linedata, charsmax(linedata), len)))
		{
			if (!len)
			{
				continue;
			}

			if (is_invalid_str(linedata))
			{
				continue;
			}

			if (equal(arg, linedata))
			{
				console_print(id, "%s %L", PREFIX, id, "SB_ALRDY_BANNED");
				return PLUGIN_HANDLED;
			}
		}
	}

	if (write_file(subnets_file, arg))
	{
		if (get_pcvar_num(pcvar_logging) != 0)
		{
			if (id == 0)
			{
				log_to_file(logs_file, "Subnet \"%s\" successfully banned by server console.", arg);
			}
			else
			{
				new admin[32];
				get_user_name(id, admin, charsmax(admin));
				log_to_file(logs_file, "Subnet \"%s\" successfully banned by %s", arg, admin);
			}
		}

		console_print(id, "%s %L", PREFIX, id, "SB_BANNED");
		set_task(1.0, "cache_variables");
	}

	return PLUGIN_HANDLED;
}

public concmd_Unban(id, level, cid)
{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;

	if (!file_exists(subnets_file))
	{
		console_print(id, "%s %L", PREFIX, id, "SB_NOTFOUND");
		return PLUGIN_HANDLED;
	}

	if (subnets_num() == 0)
	{
		console_print(id, "%s %L", PREFIX, id, "SB_FINDERROR");
		return PLUGIN_HANDLED;
	}

	new arg[32];
	read_argv(1, arg, charsmax(arg));

	if (is_invalid_str(arg) || !is_valid_subnet(arg))
	{
		server_print("%s %L", PREFIX, id, "SB_UNKNOWN_INPUT", arg);
		return PLUGIN_HANDLED;
	}

	new backup_file[64];
	format(backup_file, charsmax(backup_file), "%s/subnets.bak", data_dir);

	new line = 0, linedata[1024], len, found = -1;

	while ((line = read_file(subnets_file, line, linedata, charsmax(linedata), len)))
	{
		if (!len)
		{
			continue;
		}

		if (equal(arg, linedata))
		{
			found = line - 1;
		}
	}

	if (found == -1)
	{
		console_print(id, "%s %L", PREFIX, id, "SB_NOT_BANNED");
		return PLUGIN_HANDLED;
	}
	else if (found == 0)
	{
		write_file(backup_file, "");
	}

	line = 0;

	while ((line = read_file(subnets_file, line, linedata, charsmax(linedata), len)))
	{
		if ((line - 1) == found)
		{
			continue;
		}

		write_file(backup_file, linedata);
	}

	if (delete_file(subnets_file))
	{
		if (get_pcvar_num(pcvar_logging) != 0)
		{
			if (id == 0)
			{
				log_to_file(logs_file, "Subnet \"%s\" successfully unbanned by server console.", arg);
			}
			else
			{
				new admin[32];
				get_user_name(id, admin, charsmax(admin));
				log_to_file(logs_file, "Subnet \"%s\" successfully unbanned by %s", arg, admin);
			}
		}

		rename_file(backup_file, subnets_file, 1);
		console_print(id, "%s %L", PREFIX, id, "SB_UNBANNED");
		set_task(1.0, "cache_variables");
	}

	return PLUGIN_HANDLED;
}

public concmd_Banlist(id, level, cid)
{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;

	if (!file_exists(subnets_file))
	{
		console_print(id, "%s %L", PREFIX, id, "SB_NOTFOUND");
		return PLUGIN_HANDLED;
	}

	if (subnets_num() == 0)
	{
		console_print(id, "%s %L", PREFIX, id, "SB_FINDERROR");
		return PLUGIN_HANDLED;
	}

	new cmd[32], arg[8];
	read_argv(0, cmd, charsmax(cmd));
	new start = read_argv(1, arg, charsmax(arg)) ? str_to_num(arg) : 1;
	new end = start + LISTAMOUNT;

	if (--start < 0)
	{
		start = 0;
	}

	if (start >= subnets_num())
	{
		start = subnets_num() - 1;
	}

	if (end > subnets_num())
	{
		end = subnets_num();
	}

	for (new i = start; i < end; i++)
	{
		console_print(id, "%a", ArrayGetStringHandle(_subnet, i));
	}

	console_print(id, "%s %L", PREFIX, id, "SB_LIST_ENTRIES", start + 1, end, subnets_num());

	if (end < subnets_num())
	{
		console_print(id, "%L", id, "SB_LIST_USE_MORE", cmd,  end + 1);
	}
	else
	{
		console_print(id, "%L", id, "SB_LIST_USE_BEGIN", cmd);
	}

	return PLUGIN_HANDLED;
}

public concmd_Who(id, level, cid)
{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED;

	new players[MAXPLAYERS], num;
	get_players(players, num);

	if (num == 0)
	{
		console_print(id, "%s %L", PREFIX, id, "SB_WITHOUTPL");
		return PLUGIN_HANDLED;
	}

	console_print(id, "%s %L", PREFIX, id, "SB_IPS");

	for (new i = 0; i < num; i++)
	{
		new name[32], ip[16];
		get_user_name(players[i], name, charsmax(name));
		get_user_ip(players[i], ip, charsmax(ip), 1);

		console_print(id, "%d. %s (IP: %s)", i + 1, name, ip);
	}

	return PLUGIN_HANDLED;
}

public cache_variables()
{
	new line = 0, linedata[1024], len;

	ArrayClear(_subnet);

	if (file_exists(subnets_file))
	{
		while ((line = read_file(subnets_file, line, linedata, charsmax(linedata), len)))
		{
			if (!len)
			{
				continue;
			}

			if (is_invalid_str(linedata))
			{
				continue;
			}

			ArrayPushString(_subnet, linedata);
		}
	}
}

stock subnets_num()
{
	return ArraySize(_subnet);
}

stock remove(text[], len, const what[])
{
	return replace_all(text, len, what, "");
}

stock bool:is_invalid_str(const string[])
{
	if (!string[0] || string[0] == ';' || string[0] == '#' || string[0] == '/' && string[1] == '/')
	{
		return true;
	}

	return false;
}